# Network v2 Commands

## address group

An address group is a group of IPv4 or IPv6 address blocks which could be referenced as a remote source or destination when creating a security group rule.

### address group create

Create a new Address Group

    openstack address group create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--address <ip-address>]
        [--project <project>]
        [--project-domain <project-domain>]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  New address group description

--address <ip-address>

  IP address or CIDR (repeat option to set multiple addresses)

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

name

  New address group name

### address group delete

Delete address group(s)

    openstack address group delete <address-group> [<address-group> ...]

address-group

  Address group(s) to delete (name or ID)

### address group list

List address groups

    openstack address group list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--name <name>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--name <name>

  List only address groups with the specified name

--project <project>

  List only address groups with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### address group set

Set address group properties

    openstack address group set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--description <description>]
        [--address <ip-address>]
        <address-group>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Set address group name

--description <description>

  Set address group description

--address <ip-address>

  IP address or CIDR (repeat option to set multiple addresses)

address-group

  Address group to modify (name or ID)

### address group show

Display address group details

    openstack address group show <address-group>

address-group

  Address group to display (name or ID)

### address group unset

Unset address group properties

    openstack address group unset [--address <ip-address>] <address-group>

--address <ip-address>

  IP address or CIDR (repeat option to unset multiple addresses)

address-group

  Address group to modify (name or ID)

## address scope

An address scope is a scope of IPv4 or IPv6 addresses that belongs to a given project and may be shared between projects.

### address scope create

Create a new Address Scope

    openstack address scope create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--ip-version {4,6}]
        [--project <project>]
        [--project-domain <project-domain>]
        [--share | --no-share]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--ip-version <IP_VERSION>

  IP version (default is 4)

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--share

  Share the address scope between projects

--no-share

  Do not share the address scope between projects (default)

name

  New address scope name

### address scope delete

Delete address scope(s)

    openstack address scope delete <address-scope> [<address-scope> ...]

address-scope

  Address scope(s) to delete (name or ID)

### address scope list

List address scopes

    openstack address scope list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--name <name>]
        [--ip-version <ip-version>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]
        [--share
        |
        --no-share
        ]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--name <name>

  List only address scopes with the specified name

--ip-version <ip-version>

  List only address scopes with the specified IP version networks (4 or 6)

--project <project>

  List only address scopes with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

--share

  List only address scopes shared between projects

--no-share

  List only address scopes not shared between projects

### address scope set

Set address scope properties

    openstack address scope set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--share | --no-share]
        <address-scope>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Set address scope name

--share

  Share the address scope between projects

--no-share

  Do not share the address scope between projects

address-scope

  Address scope to modify (name or ID)

### address scope show

Display address scope details

    openstack address scope show <address-scope>

address-scope

  Address scope to display (name or ID)

## default security group rule

A default security group rule specifies the template of the security group rules which will be used by neutron to create rules in every new security group.

### default security group rule create

Add a new security group rule to the default security group template.

These rules will be applied to the default security groups created for any new project. They will not be applied to any existing default security groups.

    openstack default security group rule create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--icmp-type <icmp-type>]
        [--icmp-code <icmp-code>]
        [--ingress | --egress]
        [--ethertype <ethertype>]
        [--remote-ip
        <ip-address>
        |
        --remote-group <group>
        |
        --remote-address-group <group>
        ]
        [--dst-port <port-range>]
        [--protocol <protocol>]
        [--for-default-sg]
        [--for-custom-sg]

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Set default security group rule description

--icmp-type <icmp-type>

  ICMP type for ICMP IP protocols

--icmp-code <icmp-code>

  ICMP code for ICMP IP protocols

--ingress

  Rule will apply to incoming network traffic (default)

--egress

  Rule will apply to outgoing network traffic

--ethertype <ethertype>

  Ethertype of network traffic (IPv4, IPv6; default: based on IP protocol)

--remote-ip <ip-address>

  Remote IP address block (may use CIDR notation; default for IPv4 rule: 0.0.0.0/0, default for IPv6 rule: ::/0)

--remote-group <group>

  Remote security group (ID)

--remote-address-group <group>

  Remote address group (ID)

--dst-port <port-range>

  Destination port, may be a single port or a starting and ending port range: 137:139. Required for IP protocols TCP and UDP. Ignored for ICMP IP protocols.

--protocol <protocol>

  IP protocol (ah, dccp, egp, esp, gre, icmp, igmp, ipv66-encap, ipv6-frag, ipv6-icmp, ipv6-nonxt, ipv6-opts, ipv6-route, ospf, pgm, rsvp, sctp, tcp, udp, udplite, vrrp and integer representations [0-255] or any; default: any (all protocols))

--for-default-sg

  Set this default security group rule to be used in all default security groups created automatically for each project

--for-custom-sg

  Set this default security group rule to be used in all custom security groups created manually by users

### default security group rule delete

Remove security group rule(s) from the default security group template.

These rules will not longer be applied to the default security groups created for any new project. They will not be removed from any existing default security groups.

    openstack default security group rule delete <rule> [<rule> ...]

rule

  Default security group rule(s) to delete (ID only)

### default security group rule list

List security group rules used for new default security groups.

This shows the rules that will be added to any new default security groups created. These rules may differ for the rules present on existing default security groups.

    openstack default security group rule list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--protocol <protocol>]
        [--ethertype <ethertype>]
        [--ingress | --egress]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--protocol <protocol>

  List only default rules with the specified IP protocol (ah, dhcp, egp, esp, gre, icmp, igmp, ipv6-encap, ipv6-frag, ipv6-icmp, ipv6-nonxt, ipv6-opts, ipv6-route, ospf, pgm, rsvp, sctp, tcp, udp, udplite, vrrp and integer representations [0-255] or any; default: any (all protocols))

--ethertype <ethertype>

  List default rules by the Ethertype (IPv4 or IPv6)

--ingress

  List only default rules which will be applied to incoming network traffic

--egress

  List only default rules which will be applied to outgoing network traffic

### default security group rule show

Show a security group rule used for new default security groups.

This shows a rule that will be added to any new default security groups created. This rule may not be present on existing default security groups.

    openstack default security group rule show <rule>

rule

  Default security group rule to display (ID only)

## floating ip port forwarding

### floating ip port forwarding create

Create floating IP port forwarding

    openstack floating ip port forwarding create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        --internal-ip-address <internal-ip-address>
        --port <port>
        --internal-protocol-port <port-number>
        --external-protocol-port <port-number>
        --protocol <protocol>
        [--description <description>]
        <floating-ip>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--internal-ip-address <internal-ip-address>

  The fixed IPv4 address of the network port associated to the floating IP port forwarding

--port <port>

  The name or ID of the network port associated to the floating IP port forwarding

--internal-protocol-port <port-number>

  The protocol port number of the network port fixed IPv4 address associated to the floating IP port forwarding

--external-protocol-port <port-number>

  The protocol port number of the port forwarding’s floating IP address

--protocol <protocol>

  The protocol used in the floating IP port forwarding, for instance: TCP, UDP

--description <description>

  Text to describe/contextualize the use of the port forwarding configuration

floating-ip

  Floating IP that the port forwarding belongs to (IP address or ID)

### floating ip port forwarding delete

Delete floating IP port forwarding

    openstack floating ip port forwarding delete
        <floating-ip>
        <port-forwarding-id>
        [<port-forwarding-id> ...]

floating-ip

  Floating IP that the port forwarding belongs to (IP address or ID)

port-forwarding-id

  The ID of the floating IP port forwarding(s) to delete

### floating ip port forwarding list

List floating IP port forwarding

    openstack floating ip port forwarding list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--port <port>]
        [--external-protocol-port <port-number>]
        [--protocol <protocol>]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]
        <floating-ip>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--port <port>

  List only floating IP port forwardings with the specified internal network port (name or ID)

--external-protocol-port <port-number>

  List only floating IP port forwardings with the specified external protocol port number

--protocol <protocol>

  List only floating IP port forwardings with the specified protocol number

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

floating-ip

  Floating IP that the port forwarding belongs to (IP address or ID)

### floating ip port forwarding set

Set floating IP Port Forwarding Properties

    openstack floating ip port forwarding set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--port <port>]
        [--internal-ip-address <internal-ip-address>]
        [--internal-protocol-port <port-number>]
        [--external-protocol-port <port-number>]
        [--protocol <protocol>]
        [--description <description>]
        <floating-ip>
        <port-forwarding-id>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--port <port>

  The ID of the network port associated to the floating IP port forwarding

--internal-ip-address <internal-ip-address>

  The fixed IPv4 address of the network port associated to the floating IP port forwarding

--internal-protocol-port <port-number>

  The TCP/UDP/other protocol port number of the network port fixed IPv4 address associated to the floating IP port forwarding

--external-protocol-port <port-number>

  The TCP/UDP/other protocol port number of the port forwarding’s floating IP address

--protocol <protocol>

  The IP protocol used in the floating IP port forwarding

--description <description>

  Text to describe/contextualize the use of the port forwarding configuration

floating-ip

  Floating IP that the port forwarding belongs to (IP address or ID)

port-forwarding-id

  The ID of the floating IP port forwarding

### floating ip port forwarding show

Display floating IP Port Forwarding details

    openstack floating ip port forwarding show
        <floating-ip>
        <port-forwarding-id>

floating-ip

  Floating IP that the port forwarding belongs to (IP address or ID)

port-forwarding-id

  The ID of the floating IP port forwarding

## floating ip

### floating ip create

Create floating IP

    openstack floating ip create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--subnet <subnet>]
        [--port <port>]
        [--floating-ip-address <ip-address>]
        [--fixed-ip-address <ip-address>]
        [--qos-policy <qos-policy>]
        [--description <description>]
        [--project <project>]
        [--dns-domain <dns-domain>]
        [--dns-name <dns-name>]
        [--project-domain <project-domain>]
        [--tag <tag> | --no-tag]
        <network>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--subnet <subnet>

  Subnet on which you want to create the floating IP (name or ID)

--port <port>

  Port to be associated with the floating IP (name or ID)

--floating-ip-address <ip-address>

  Floating IP address

--fixed-ip-address <ip-address>

  Fixed IP address mapped to the floating IP

--qos-policy <qos-policy>

  Attach QoS policy to the floating IP (name or ID)

--description <description>

  Set floating IP description

--project <project>

  Owner’s project (name or ID)

--dns-domain <dns-domain>

  Set DNS domain for this floating IP

--dns-name <dns-name>

  Set DNS name for this floating IP

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--tag <tag>

  Tag to be added to the floating IP (repeat option to set multiple tags)

--no-tag

  No tags associated with the floating IP

network

  Network to allocate floating IP from (name or ID)

### floating ip delete

Delete floating IP(s)

    openstack floating ip delete <floating-ip> [<floating-ip> ...]

floating-ip

  Floating IP(s) to delete (IP address or ID)

### floating ip list

List floating IP(s)

    openstack floating ip list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--network <network>]
        [--port <port>]
        [--fixed-ip-address <ip-address>]
        [--floating-ip-address <ip-address>]
        [--status <status>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--router <router>]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]
        [--long]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--network <network>

  List only floating IP(s) with the specified network (name or ID) (repeat option to fiter on multiple networks)

--port <port>

  List only floating IP(s) with the specified port (name or ID) (repeat option to fiter on multiple ports)

--fixed-ip-address <ip-address>

  List only floating IP(s) with the specified fixed IP address

--floating-ip-address <ip-address>

  List only floating IP(s) with the specified floating IP address

--status <status>

  List only floating IP(s) with the specified status (‘ACTIVE’, ‘DOWN’)

--project <project>

  List only floating IP(s) with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--router <router>

  List only floating IP(s) with the specified router (name or ID) (repeat option to fiter on multiple routers)

--tags <tag>[,<tag>,...]

  List floating IP which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List floating IP which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude floating IP which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude floating IP which have any given tag(s) (Comma-separated list of tags)

--long

  List additional fields in output

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### floating ip set

Set floating IP Properties

    openstack floating ip set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--port <port>]
        [--fixed-ip-address <ip-address>]
        [--description <description>]
        [--qos-policy <qos-policy> | --no-qos-policy]
        [--tag <tag>]
        [--no-tag]
        <floating-ip>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--port <port>

  Associate the floating IP with port (name or ID)

--fixed-ip-address <ip-address>

  Fixed IP of the port (required only if port has multiple IPs)

--description <description>

  Set floating IP description

--qos-policy <qos-policy>

  Attach QoS policy to the floating IP (name or ID)

--no-qos-policy

  Remove the QoS policy attached to the floating IP

--tag <tag>

  Tag to be added to the floating IP (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the floating IP. Specify both –tag and –no-tag to overwrite current tags

floating-ip

  Floating IP to modify (IP address or ID)

### floating ip show

Display floating IP details

    openstack floating ip show <floating-ip>

floating-ip

  Floating IP to display (IP address or ID)

### floating ip unset

Unset floating IP Properties

    openstack floating ip unset
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--port]
        [--qos-policy]
        [--tag
        <tag>
        |
        --all-tag
        ]
        <floating-ip>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--port

  Disassociate any port associated with the floating IP

--qos-policy

  Remove the QoS policy attached to the floating IP

--tag <tag>

  Tag to be removed from the floating IP (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the floating IP

floating-ip

  Floating IP to disassociate (IP address or ID)

## ip availability

### ip availability list

List IP availability for network

    openstack ip availability list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--ip-version <ip-version>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--ip-version <ip-version>

  List only IP availability with the specified IP version networks (4 or 6, default is 4)

--project <project>

  List only IP availability with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### ip availability show

Show network IP availability details

    openstack ip availability show <network>

network

  Show IP availability for a specific network (name or ID)

## Local IP Associations (local_ip_associations)

The resource lets users assign Local IPs to user Ports. This is a sub-resource of the Local IP resource.

### local ip association create

Create Local IP Association

    openstack local ip association create
        [--fixed-ip <fixed-ip>]
        [--project-domain <project-domain>]
        <local-ip>
        <fixed-port>

--fixed-ip <fixed-ip>

  Fixed IP for Local IP Association

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

local-ip

  Local IP that the port association belongs to (Name or ID)

fixed-port

  The ID or Name of Port to allocate Local IP Association

### local ip association delete

Delete Local IP association(s)

    openstack local ip association delete
        <local-ip>
        <fixed-port-id>
        [<fixed-port-id> ...]

local-ip

  Local IP that the port association belongs to (Name or ID)

fixed-port-id

  The fixed port ID of Local IP Association

### local ip association list

List Local IP Associations

    openstack local ip association list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--fixed-port <fixed-port>]
        [--fixed-ip <fixed-ip>]
        [--host <host>]
        [--project-domain <project-domain>]
        <local-ip>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--fixed-port <fixed-port>

  List only local IP assocations with the specified fixed IP port (name or ID)

--fixed-ip <fixed-ip>

  List only local IP associations with the specified fixed IP

--host <host>

  List only local IP associations with the specified host

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

local-ip

  Local IP that port associations belongs to

## Local IPs (local_ips)

Extension that allows users to create a virtual IP that can later be assigned to multiple ports/VMs (similar to anycast IP) and is guaranteed to only be reachable within the same physical server/node boundaries

### local ip association create

Create Local IP Association

    openstack local ip association create
        [--fixed-ip <fixed-ip>]
        [--project-domain <project-domain>]
        <local-ip>
        <fixed-port>

--fixed-ip <fixed-ip>

  Fixed IP for Local IP Association

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

local-ip

  Local IP that the port association belongs to (Name or ID)

fixed-port

  The ID or Name of Port to allocate Local IP Association

### local ip association delete

Delete Local IP association(s)

    openstack local ip association delete
        <local-ip>
        <fixed-port-id>
        [<fixed-port-id> ...]

local-ip

  Local IP that the port association belongs to (Name or ID)

fixed-port-id

  The fixed port ID of Local IP Association

### local ip association list

List Local IP Associations

    openstack local ip association list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--fixed-port <fixed-port>]
        [--fixed-ip <fixed-ip>]
        [--host <host>]
        [--project-domain <project-domain>]
        <local-ip>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--fixed-port <fixed-port>

  List only local IP assocations with the specified fixed IP port (name or ID)

--fixed-ip <fixed-ip>

  List only local IP associations with the specified fixed IP

--host <host>

  List only local IP associations with the specified host

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

local-ip

  Local IP that port associations belongs to

### local ip create

Create Local IP

    openstack local ip create
        [--name <name>]
        [--description <description>]
        [--network <network>]
        [--local-port <local-port>]
        [--local-ip-address <local-ip-address>]
        [--ip-mode <ip-mode>]
        [--project-domain <project-domain>]

--name <name>

  New Local IP name

--description <description>

  Description for Local IP

--network <network>

  Network to allocate Local IP from (name or ID)

--local-port <local-port>

  Port to allocate Local IP from (name or ID)

--local-ip-address <local-ip-address>

  IP address or CIDR for Local IP

--ip-mode <ip-mode>

  IP mode to use for Local IP

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

### local ip delete

Delete Local IP(s)

    openstack local ip delete <local-ip> [<local-ip> ...]

local-ip

  Local IP(s) to delete (name or ID)

### local ip list

List Local IPs

    openstack local ip list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--name <name>]
        [--project <project>]
        [--network <network>]
        [--local-port <local-port>]
        [--local-ip-address <local-ip-address>]
        [--ip-mode <ip_mode>]
        [--project-domain <project-domain>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--name <name>

  List only local IP(s) with the specified name

--project <project>

  List only local IP(s) with the specified project (name or ID)

--network <network>

  List only local IP(s) with the specified network (name or ID)

--local-port <local-port>

  List only local IP(s) with the specified port (name or ID)

--local-ip-address <local-ip-address>

  List only local IP(s) with the specified IP address

--ip-mode <ip_mode>

  List only local IP(s) with the specified IP mode

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

### local ip set

Set Local IP properties

    openstack local ip set
        [--name <name>]
        [--description <description>]
        <local-ip>

--name <name>

  Set local IP name

--description <description>

  Set Local IP description

local-ip

  Local IP to modify (name or ID)

### local ip show

Display Local IP details

    openstack local ip show <local-ip>

local-ip

  Local IP to display (name or ID)

## network agent

A network agent is an agent that handles various tasks used to implement virtual networks. These agents include neutron-dhcp-agent, neutron-l3-agent, neutron-metering-agent, and neutron-lbaas-agent, among others. The agent is available when the alive status of the agent is “True”.

### network agent add network

Add network to an agent

    openstack network agent add network [--dhcp] <agent-id> <network>

--dhcp

  Add network to a DHCP agent

agent-id

  Agent to which a network is added (ID only)

network

  Network to be added to an agent (name or ID)

### network agent add router

Add router to an agent

    openstack network agent add router
        [--l3]
        [--ha-chassis-priority <ha-chassis-priority>]
        <agent-id>
        <router>

--l3

  Add router to an L3 agent

--ha-chassis-priority <ha-chassis-priority>

  HA Chassis priority, ranging from [0, 32767]. Only used with –l3 and for ML2/OVN L3 agents

agent-id

  Agent to which a router is added (ID only)

router

  Router to be added to an agent (name or ID)

### network agent delete

Delete network agent(s)

    openstack network agent delete <network-agent> [<network-agent> ...]

network-agent

  Network agent(s) to delete (ID only)

### network agent list

List network agents

    openstack network agent list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--agent-type <agent-type>]
        [--host <host>]
        [--network
        <network>
        |
        --router <router>
        ]
        [--long]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--agent-type <agent-type>

  List only agents with the specified agent type. The supported agent types are: bgp,dhcp,open-vswitch,linux-bridge,ofa,l3,loadbalancer,metering,metadata,macvtap,nic,baremetal,ovn-controller,ovn-controller-gateway,ovn-metadata,ovn-agent.

--host <host>

  List only agents running on the specified host

--network <network>

  List agents hosting the specified network (name or ID)

--router <router>

  List agents hosting the specified router (name or ID)

--long

  List additional fields in output

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network agent remove network

Remove network from an agent.

    openstack network agent remove network [--dhcp] <agent-id> <network>

--dhcp

  Remove network from DHCP agent

agent-id

  Agent to which a network is removed (ID only)

network

  Network to be removed from an agent (name or ID)

### network agent remove router

Remove router from an agent

    openstack network agent remove router [--l3] <agent-id> <router>

--l3

  Remove router from an L3 agent

agent-id

  Agent from which router will be removed (ID only)

router

  Router to be removed from an agent (name or ID)

### network agent router set

Set properties of a router associated to an agent

    openstack network agent router set
        --ha-chassis-priority <ha-chassis-priority>
        <agent-id>
        <router>

--ha-chassis-priority <ha-chassis-priority>

  HA Chassis priority, ranging from [0, 32767]. Only used with –l3 and for ML2/OVN L3 agents

agent-id

  L3 agent to modify (ID only)

router

  Router to update (name or ID)

### network agent set

Set network agent properties

    openstack network agent set
        [--description <description>]
        [--enable
        |
        --disable
        ]
        <network-agent>

--description <description>

  Set network agent description

--enable

  Enable network agent

--disable

  Disable network agent

network-agent

  Network agent to modify (ID only)

### network agent show

Display network agent details

    openstack network agent show <network-agent>

network-agent

  Network agent to display (ID only)

## network auto allocated topology

An auto allocated topology allows admins to quickly set up external connectivity for end-users. Only one auto allocated topology is allowed per project. For more information on how to set up the resources required for auto allocated topology review the documentation.

### network auto allocated topology create

Create the auto allocated topology for project

    openstack network auto allocated topology create
        [--project <project>]
        [--project-domain <project-domain>]
        [--check-resources]
        [--or-show]

--project <project>

  Return the auto allocated topology for a given project. Default is current project.

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--check-resources

  Validate the requirements for auto allocated topology. Does not return a topology.

--or-show

  If topology exists returns the topology’s information (default)

### network auto allocated topology delete

Delete auto allocated topology for project

    openstack network auto allocated topology delete
        [--project <project>]
        [--project-domain <project-domain>]

--project <project>

  Delete auto allocated topology for a given project. Default is the current project.

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

## network flavor profile

A network flavor profile allows administrators to create, delete, list, show and update network service profile, which details a framework to enable operators to configure and users to select from different abstract representations of a service implementation in the Networking service. It decouples the logical configuration from its instantiation enabling operators to create user options according to deployment needs.

### network flavor profile create

Create new network flavor profile

    openstack network flavor profile create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--enable | --disable]
        [--driver DRIVER]
        [--metainfo METAINFO]

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Description for the flavor profile

--enable

  Enable the flavor profile

--disable

  Disable the flavor profile

--driver <DRIVER>

  Python module path to driver. This becomes required if –metainfo is missing and vice-versa.

--metainfo <METAINFO>

  Metainfo for the flavor profile. This becomes required if –driver is missing and vice-versa.

### network flavor profile delete

Delete network flavor profile

    openstack network flavor profile delete
        <flavor-profile>
        [<flavor-profile> ...]

flavor-profile

  Flavor profile(s) to delete (ID only)

### network flavor profile list

List network flavor profile(s)

    openstack network flavor profile list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network flavor profile set

Set network flavor profile properties

    openstack network flavor profile set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--enable | --disable]
        [--driver DRIVER]
        [--metainfo METAINFO]
        <flavor-profile>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Description for the flavor profile

--enable

  Enable the flavor profile

--disable

  Disable the flavor profile

--driver <DRIVER>

  Python module path to driver. This becomes required if –metainfo is missing and vice-versa.

--metainfo <METAINFO>

  Metainfo for the flavor profile. This becomes required if –driver is missing and vice-versa.

flavor-profile

  Flavor profile to update (ID only)

### network flavor profile show

Display network flavor profile details

    openstack network flavor profile show <flavor-profile>

flavor-profile

  Flavor profile to display (ID only)

## network flavor

A network flavor extension allows the user selection of operator-curated flavors during resource creations. It allows administrators to create network service flavors.

### network flavor add profile

Add a service profile to a network flavor

    openstack network flavor add profile <flavor> <service-profile>

flavor

  Network flavor (name or ID)

service-profile

  Service profile (ID only)

### network flavor create

Create new network flavor

    openstack network flavor create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        --service-type <service-type>
        [--description DESCRIPTION]
        [--project <project>]
        [--project-domain <project-domain>]
        [--enable | --disable]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--service-type <service-type>

  Service type to which the flavor applies. For example: VPN (See openstack network service provider list for loaded examples.)

--description <DESCRIPTION>

  Description for the flavor

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--enable

  Enable the flavor (default)

--disable

  Disable the flavor

name

  Name for the flavor

### network flavor delete

Delete network flavors

    openstack network flavor delete <flavor> [<flavor> ...]

flavor

  Flavor(s) to delete (name or ID)

### network flavor list

List network flavors

    openstack network flavor list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network flavor remove profile

Remove service profile from network flavor

    openstack network flavor remove profile <flavor> <service-profile>

flavor

  Network flavor (name or ID)

service-profile

  Service profile (ID only)

### network flavor set

Set network flavor properties

    openstack network flavor set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description DESCRIPTION]
        [--disable
        |
        --enable
        ]
        [--name <name>]
        <flavor>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <DESCRIPTION>

  Set network flavor description

--disable

  Disable network flavor

--enable

  Enable network flavor

--name <name>

  Set flavor name

flavor

  Flavor to update (name or ID)

### network flavor show

Display network flavor details

    openstack network flavor show <flavor>

flavor

  Flavor to display (name or ID)

## network l3 conntrack helper

### network l3 conntrack helper create

Create a new L3 conntrack helper

    openstack network l3 conntrack helper create
        --helper <helper>
        --protocol <protocol>
        --port <port>
        <router>

--helper <helper>

  The netfilter conntrack helper module

--protocol <protocol>

  The network protocol for the netfilter conntrack target rule

--port <port>

  The network port for the netfilter conntrack target rule

router

  Router for which conntrack helper will be created

### network l3 conntrack helper delete

Delete L3 conntrack helper

    openstack network l3 conntrack helper delete
        <router>
        <conntrack-helper-id>
        [<conntrack-helper-id> ...]

router

  Router that the conntrack helper belongs to

conntrack-helper-id

  The ID of the conntrack helper(s) to delete

### network l3 conntrack helper list

List L3 conntrack helpers

    openstack network l3 conntrack helper list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--helper <helper>]
        [--protocol <protocol>]
        [--port <port>]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]
        <router>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--helper <helper>

  List only helpers using the specified netfilter conntrack helper module

--protocol <protocol>

  List only helpers with the specified network protocol for the netfilter conntrack target rule

--port <port>

  List only helpers with the specified network port for the netfilter conntrack target rule (name or ID)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

router

  Router that the conntrack helper belongs to

### network l3 conntrack helper set

Set L3 conntrack helper properties

    openstack network l3 conntrack helper set
        [--helper <helper>]
        [--protocol <protocol>]
        [--port <port>]
        <router>
        <conntrack-helper-id>

--helper <helper>

  The netfilter conntrack helper module

--protocol <protocol>

  The network protocol for the netfilter conntrack target rule

--port <port>

  The network port for the netfilter conntrack target rule

router

  Router that the conntrack helper belongs to

conntrack-helper-id

  The ID of the conntrack helper(s)

### network l3 conntrack helper show

Display L3 conntrack helper details

    openstack network l3 conntrack helper show
        <router>
        <conntrack-helper-id>

router

  Router that the conntrack helper belongs to

conntrack-helper-id

  The ID of the conntrack helper

## network meter rule

A meter rule sets the rule for a meter to measure traffic for a specific IP range. The following uses meter and requires the L3 metering extension.

### network meter rule create

Create a new meter rule

    openstack network meter rule create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--exclude | --include]
        [--ingress | --egress]
        [--remote-ip-prefix <remote-ip-prefix>]
        [--source-ip-prefix <remote-ip-prefix>]
        [--destination-ip-prefix <remote-ip-prefix>]
        <meter>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--exclude

  Exclude remote IP prefix from traffic count

--include

  Include remote IP prefix from traffic count (default)

--ingress

  Apply rule to incoming network traffic (default)

--egress

  Apply rule to outgoing network traffic

--remote-ip-prefix <remote-ip-prefix>

  The remote IP prefix to associate with this rule

--source-ip-prefix <remote-ip-prefix>

  The source IP prefix to associate with this rule

--destination-ip-prefix <remote-ip-prefix>

  The destination IP prefix to associate with this rule

meter

  Label to associate with this metering rule (name or ID)

### network meter rule delete

Delete meter rule(s)

    openstack network meter rule delete
        <meter-rule-id>
        [<meter-rule-id> ...]

meter-rule-id

  Meter rule to delete (ID only)

### network meter rule list

List meter rules

    openstack network meter rule list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network meter rule show

Display meter rules details

    openstack network meter rule show <meter-rule-id>

meter-rule-id

  Meter rule (ID only)

## network meter

A network meter allows operators to measure traffic for a specific IP range. The following commands are specific to the L3 metering extension.

### network meter create

Create network meter

    openstack network meter create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--share | --no-share]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Description for meter

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--share

  Share meter between projects

--no-share

  Do not share meter between projects

name

  Name of meter

### network meter delete

Delete network meter

    openstack network meter delete <meter> [<meter> ...]

meter

  Meter to delete (name or ID)

### network meter list

List network meters

    openstack network meter list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network meter show

Show network meter

    openstack network meter show <meter>

meter

  Meter to display (name or ID)

## network qos policy

A Network QoS policy groups a number of Network QoS rules, applied to a network or a port.

### network qos policy create

Create a QoS policy

    openstack network qos policy create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--share | --no-share]
        [--project <project>]
        [--project-domain <project-domain>]
        [--default | --no-default]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Description of the QoS policy

--share

  Make the QoS policy accessible by other projects

--no-share

  Make the QoS policy not accessible by other projects (default)

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--default

  Set this as a default network QoS policy

--no-default

  Set this as a non-default network QoS policy

name

  Name of QoS policy to create

### network qos policy delete

Delete Qos Policy(s)

    openstack network qos policy delete <qos-policy> [<qos-policy> ...]

qos-policy

  QoS policy(s) to delete (name or ID)

### network qos policy list

List QoS policies

    openstack network qos policy list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--project <project>]
        [--project-domain <project-domain>]
        [--share | --no-share]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--project <project>

  List only QoS policies with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--share

  List only QoS policies shared between projects

--no-share

  List only QoS policies not shared between projects

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network qos policy set

Set QoS policy properties

    openstack network qos policy set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--description <description>]
        [--share | --no-share]
        [--default
        |
        --no-default
        ]
        <qos-policy>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Set QoS policy name

--description <description>

  Description of the QoS policy

--share

  Make the QoS policy accessible by other projects

--no-share

  Make the QoS policy not accessible by other projects

--default

  Set this as a default network QoS policy

--no-default

  Set this as a non-default network QoS policy

qos-policy

  QoS policy to modify (name or ID)

### network qos policy show

Display QoS policy details

    openstack network qos policy show <qos-policy>

qos-policy

  QoS policy to display (name or ID)

## network qos rule type

A Network QoS rule type is a specific Network QoS rule type available to be used.

### network qos rule type list

List QoS rule types

    openstack network qos rule type list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--all-supported | --all-rules]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--all-supported

  List all the QoS rule types supported by any loaded mechanism drivers (the union of all sets of supported rules)

--all-rules

  List all QoS rule types implemented in Neutron QoS driver

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network qos rule type show

Show details about supported QoS rule type

    openstack network qos rule type show <qos-rule-type-name>

qos-rule-type-name

  Name of QoS rule type

## network qos rule

A Network QoS rule specifies a rule defined in a Network QoS policy; its type is defined by the parameter ‘type’. Can be assigned, within a Network QoS policy, to a port or a network. Each Network QoS policy can contain several rules, each of them

### network qos rule create

Create new Network QoS rule

    openstack network qos rule create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        --type <type>
        [--max-kbps <max-kbps>]
        [--max-burst-kbits <max-burst-kbits>]
        [--dscp-mark <dscp-mark>]
        [--min-kbps <min-kbps>]
        [--min-kpps <min-kpps>]
        [--ingress
        |
        --egress
        |
        --any
        ]
        <qos-policy>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--type <type>

  QoS rule type (minimum-bandwidth, minimum-packet-rate, dscp-marking, bandwidth-limit)

--max-kbps <max-kbps>

  Maximum bandwidth in kbps

--max-burst-kbits <max-burst-kbits>

  Maximum burst in kilobits, 0 or not specified means automatic, which is 80%% of the bandwidth limit, which works for typical TCP traffic. For details check the QoS user workflow.

--dscp-mark <dscp-mark>

  DSCP mark: value can be 0, even numbers from 8-56, excluding 42, 44, 50, 52, and 54

--min-kbps <min-kbps>

  Minimum guaranteed bandwidth in kbps

--min-kpps <min-kpps>

  Minimum guaranteed packet rate in kpps

--ingress

  Ingress traffic direction from the project point of view

--egress

  Egress traffic direction from the project point of view

--any

  Any traffic direction from the project point of view. Can be used only with minimum packet rate rule.

qos-policy

  QoS policy that contains the rule (name or ID)

### network qos rule delete

Delete Network QoS rule

    openstack network qos rule delete <qos-policy> <rule-id>

qos-policy

  QoS policy that contains the rule (name or ID)

rule-id

  Network QoS rule to delete (ID)

### network qos rule list

List Network QoS rules

    openstack network qos rule list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        <qos-policy>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

qos-policy

  QoS policy that contains the rule (name or ID)

### network qos rule set

Set Network QoS rule properties

    openstack network qos rule set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--max-kbps <max-kbps>]
        [--max-burst-kbits <max-burst-kbits>]
        [--dscp-mark <dscp-mark>]
        [--min-kbps <min-kbps>]
        [--min-kpps <min-kpps>]
        [--ingress
        |
        --egress
        |
        --any
        ]
        <qos-policy>
        <rule-id>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--max-kbps <max-kbps>

  Maximum bandwidth in kbps

--max-burst-kbits <max-burst-kbits>

  Maximum burst in kilobits, 0 or not specified means automatic, which is 80%% of the bandwidth limit, which works for typical TCP traffic. For details check the QoS user workflow.

--dscp-mark <dscp-mark>

  DSCP mark: value can be 0, even numbers from 8-56, excluding 42, 44, 50, 52, and 54

--min-kbps <min-kbps>

  Minimum guaranteed bandwidth in kbps

--min-kpps <min-kpps>

  Minimum guaranteed packet rate in kpps

--ingress

  Ingress traffic direction from the project point of view

--egress

  Egress traffic direction from the project point of view

--any

  Any traffic direction from the project point of view. Can be used only with minimum packet rate rule.

qos-policy

  QoS policy that contains the rule (name or ID)

rule-id

  Network QoS rule to set (ID)

### network qos rule show

Display Network QoS rule details

    openstack network qos rule show <qos-policy> <rule-id>

qos-policy

  QoS policy that contains the rule (name or ID)

rule-id

  Network QoS rule to show (ID)

## network rbac

A network rbac is a Role-Based Access Control (RBAC) policy for network resources. It enables both operators and users to grant access to network resources for specific projects.

### network rbac create

Create network RBAC policy

    openstack network rbac create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        --type <type>
        --action <action>
        (--target-project
        <target-project>
        |
        --target-all-projects
        )
        [--target-project-domain <target-project-domain>]
        [--project <project>]
        [--project-domain <project-domain>]
        <rbac-object>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--type <type>

  Type of the object that RBAC policy affects (“address_group”, “address_scope”, “security_group”, “subnetpool”, “qos_policy” or “network”)

--action <action>

  Action for the RBAC policy (“access_as_external” or “access_as_shared”)

--target-project <target-project>

  The project to which the RBAC policy will be enforced (name or ID)

--target-all-projects

  Allow creating RBAC policy for all projects

--target-project-domain <target-project-domain>

  Domain the target project belongs to (name or ID). This can be used in case collisions between project names exist.

--project <project>

  The owner project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

rbac-object

  The object to which this RBAC policy affects (name or ID)

### network rbac delete

Delete network RBAC policy(s)

    openstack network rbac delete <rbac-policy> [<rbac-policy> ...]

rbac-policy

  RBAC policy(s) to delete (ID only)

### network rbac list

List network RBAC policies

    openstack network rbac list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--type <type>]
        [--action <action>]
        [--target-project <target-project>]
        [--long]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--type <type>

  List only network RBAC policies with the specified object type (“address_group”, “address_scope”, “security_group”, “subnetpool”, “qos_policy” or “network”)

--action <action>

  List only network RBAC policies with the specified action (“access_as_external” or “access_as_shared”)

--target-project <target-project>

  List only network RBAC policies with the specified target project (name or ID)

--long

  List additional fields in output

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network rbac set

Set network RBAC policy properties

    openstack network rbac set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--target-project <target-project>]
        [--target-project-domain <target-project-domain>]
        <rbac-policy>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--target-project <target-project>

  The project to which the RBAC policy will be enforced (name or ID)

--target-project-domain <target-project-domain>

  Domain the target project belongs to (name or ID). This can be used in case collisions between project names exist.

rbac-policy

  RBAC policy to be modified (ID only)

### network rbac show

Display network RBAC policy details

    openstack network rbac show <rbac-policy>

rbac-policy

  RBAC policy (ID only)

## network segment range

A network segment range is a resource for tenant network segment allocation. A network segment range exposes the segment range management to be administered via the Neutron API. In addition, it introduces the ability for the administrator to control the segment ranges globally or on a per-tenant basis.

### network segment range create

Create new network segment range

    openstack network segment range create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--private | --shared]
        [--project <project>]
        [--project-domain <project-domain>]
        --network-type <network-type>
        [--physical-network <physical-network-name>]
        --minimum <minimum-segmentation-id>
        --maximum <maximum-segmentation-id>
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--private

  Network segment range is assigned specifically to the project

--shared

  Network segment range is shared with other projects

--project <project>

  Network segment range owner (name or ID). Optional when the segment range is shared.

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--network-type <network-type>

  Network type of this network segment range (geneve, gre, vlan or vxlan)

--physical-network <physical-network-name>

  Physical network name of this network segment range

--minimum <minimum-segmentation-id>

  Minimum segment identifier for this network segment range which is based on the network type, VLAN ID for vlan network type and tunnel ID for geneve, gre and vxlan network types

--maximum <maximum-segmentation-id>

  Maximum segment identifier for this network segment range which is based on the network type, VLAN ID for vlan network type and tunnel ID for geneve, gre and vxlan network types

name

  Name of new network segment range

### network segment range delete

Delete network segment range(s)

    openstack network segment range delete
        <network-segment-range>
        [<network-segment-range> ...]

network-segment-range

  Network segment range(s) to delete (name or ID)

### network segment range list

List network segment ranges

    openstack network segment range list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--long]
        [--used | --unused]
        [--available
        |
        --unavailable
        ]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--long

  List additional fields in output

--used

  List only network segment ranges that have segments in use

--unused

  List only network segment ranges that have segments not in use

--available

  List only network segment ranges that have available segments

--unavailable

  List only network segment ranges without available segments

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network segment range set

Set network segment range properties

    openstack network segment range set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--minimum <minimum-segmentation-id>]
        [--maximum <maximum-segmentation-id>]
        <network-segment-range>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Set network segment name

--minimum <minimum-segmentation-id>

  Set network segment range minimum segment identifier

--maximum <maximum-segmentation-id>

  Set network segment range maximum segment identifier

network-segment-range

  Network segment range to modify (name or ID)

### network segment range show

Display network segment range details

    openstack network segment range show <network-segment-range>

network-segment-range

  Network segment range to display (name or ID)

## network segment

A network segment is an isolated Layer 2 segment within a network. A network may contain multiple network segments. Depending on the network configuration, Layer 2 connectivity between network segments within a network may not be guaranteed.

### network segment create

Create new network segment

    openstack network segment create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--physical-network <physical-network>]
        [--segment <segment>]
        --network <network>
        --network-type <network-type>
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Network segment description

--physical-network <physical-network>

  Physical network name of this network segment

--segment <segment>

  Segment identifier for this network segment which is based on the network type, VLAN ID for vlan network type and tunnel ID for geneve, gre and vxlan network types

--network <network>

  Network this network segment belongs to (name or ID)

--network-type <network-type>

  Network type of this network segment (flat, geneve, gre, local, vlan or vxlan)

name

  New network segment name

### network segment delete

Delete network segment(s)

    openstack network segment delete
        <network-segment>
        [<network-segment> ...]

network-segment

  Network segment(s) to delete (name or ID)

### network segment list

List network segments

    openstack network segment list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--long]
        [--network <network>]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--long

  List additional fields in output

--network <network>

  List only network segments associated with the specified network (name or ID)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network segment set

Set network segment properties

    openstack network segment set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--name <name>]
        <network-segment>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Set network segment description

--name <name>

  Set network segment name

network-segment

  Network segment to modify (name or ID)

### network segment show

Display network segment details

    openstack network segment show <network-segment>

network-segment

  Network segment to display (name or ID)

## network service provider

A network service provider is a particular driver that implements a networking service

### network service provider list

List Service Providers

    openstack network service provider list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

## network trunk

A network trunk is a container to group logical ports from different networks and provide a single trunked vNIC for servers. It consists of one parent port which is a regular VIF and multiple subports which allow the server to connect to more networks.

### network subport list

List all subports for a given network trunk

    openstack network subport list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        --trunk <trunk>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--trunk <trunk>

  List only subports belonging to this trunk (name or ID)

### network trunk create

Create a network trunk for a given project

    openstack network trunk create
        [--description <description>]
        --parent-port <parent-port>
        [--subport <port=,segmentation-type=,segmentation-id=>]
        [--enable | --disable]
        [--project <project>]
        [--project-domain <project-domain>]
        <name>

--description <description>

  A description of the trunk

--parent-port <parent-port>

  Parent port belonging to this trunk (name or ID)

--subport <port=,segmentation-type=,segmentation-id=>

  Subport to add. Subport is of form ‘port=<name or ID>,segmentation-type=<segmentation-type>,segmentation-id=<segmentation-ID>’ (repeat option to add multiple subports)

--enable

  Enable trunk (default)

--disable

  Disable trunk

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

name

  Name of the trunk to create

### network trunk delete

Delete a given network trunk

    openstack network trunk delete <trunk> [<trunk> ...]

trunk

  Trunk(s) to delete (name or ID)

### network trunk list

List all network trunks

    openstack network trunk list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--long]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--long

  List additional fields in output

### network trunk set

Set network trunk properties

    openstack network trunk set
        [--name <name>]
        [--description <description>]
        [--subport <port=,segmentation-type=,segmentation-id=>]
        [--enable | --disable]
        <trunk>

--name <name>

  Set trunk name

--description <description>

  A description of the trunk

--subport <port=,segmentation-type=,segmentation-id=>

  Subport to add. Subport is of form ‘port=<name or ID>,segmentation-type=<segmentation-type>,segmentation-id=<segmentation-ID>’ (repeat option to add multiple subports)

--enable

  Enable trunk

--disable

  Disable trunk

trunk

  Trunk to modify (name or ID)

### network trunk show

Show information of a given network trunk

    openstack network trunk show <trunk>

trunk

  Trunk to display (name or ID)

### network trunk unset

Unset subports from a given network trunk

    openstack network trunk unset --subport <subport> <trunk>

--subport <subport>

  Subport to unset (name or ID of the port) (repeat option to unset multiple subports)

trunk

  Unset subports from this trunk (name or ID)

## network

A network is an isolated Layer 2 networking segment. There are two types of networks, project and provider networks. Project networks are fully isolated and are not shared with other projects. Provider networks map to existing physical networks in the data center and provide external network access for servers and other resources. Only an OpenStack administrator can create provider networks. Networks can be connected via routers.

### network create

Create new network

    openstack network create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--share | --no-share]
        [--enable | --disable]
        [--project <project>]
        [--description <description>]
        [--mtu <mtu>]
        [--project-domain <project-domain>]
        [--availability-zone-hint <availability-zone>]
        [--enable-port-security
        |
        --disable-port-security
        ]
        [--external
        |
        --internal
        ]
        [--default | --no-default]
        [--qos-policy <qos-policy>]
        [--transparent-vlan | --no-transparent-vlan]
        [--qinq-vlan | --no-qinq-vlan]
        [--pvlan
        |
        --no-pvlan
        ]
        [--provider-network-type <provider-network-type>]
        [--provider-physical-network <provider-physical-network>]
        [--provider-segment <provider-segment>]
        [--dns-domain <dns-domain>]
        [--tag
        <tag>
        |
        --no-tag
        ]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--share

  Share the network between projects

--no-share

  Do not share the network between projects

--enable

  Enable network (default)

--disable

  Disable network

--project <project>

  Owner’s project (name or ID)

--description <description>

  Set network description

--mtu <mtu>

  Set network mtu

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--availability-zone-hint <availability-zone>

  Availability Zone in which to create this network (Network Availability Zone extension required, repeat option to set multiple availability zones)

--enable-port-security

  Enable port security by default for ports created on this network (default)

--disable-port-security

  Disable port security by default for ports created on this network

--external

  The network has an external routing facility that is not managed by Neutron and can be used. For example: openstack router set –external-gateway NETWORK (external-net extension required)

--internal

  Opposite of ‘–external’ (default)

--default

  Specify if this network should be used as the default external network

--no-default

  Do not use the network as the default external network (default)

--qos-policy <qos-policy>

  QoS policy to attach to this network (name or ID)

--transparent-vlan

  Make the network VLAN transparent

--no-transparent-vlan

  Do not make the network VLAN transparent

--qinq-vlan

  Enable VLAN QinQ (S-Tag ethtype 0x8a88) for the network

--no-qinq-vlan

  Disable VLAN QinQ (S-Tag ethtype 0x8a88) for the network

--pvlan

  Enable Private VLAN for the network (PVLAN extension required)

--no-pvlan

  Disable Private VLAN for the network (PVLAN extension required)

--provider-network-type <provider-network-type>

  The physical mechanism by which the virtual network is implemented. For example: flat, geneve, gre, local, vlan or vxlan.

--provider-physical-network <provider-physical-network>

  Name of the physical network over which the virtual network is implemented

--provider-segment <provider-segment>

  VLAN ID for VLAN networks or Tunnel ID for GENEVE/GRE/VXLAN networks

--dns-domain <dns-domain>

  Set DNS domain for this network (requires DNS integration extension)

--tag <tag>

  Tag to be added to the network (repeat option to set multiple tags)

--no-tag

  No tags associated with the network

name

  New network name

### network delete

Delete network(s)

    openstack network delete <network> [<network> ...]

network

  Network(s) to delete (name or ID)

### network list

List networks

    openstack network list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--external | --internal]
        [--long]
        [--name <name>]
        [--enable | --disable]
        [--project <project>]
        [--project-domain <project-domain>]
        [--share
        |
        --no-share
        ]
        [--status <status>]
        [--provider-network-type <provider-network-type>]
        [--provider-physical-network <provider-physical-network>]
        [--provider-segment <provider-segment>]
        [--agent <agent-id>]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--external

  List only external networks

--internal

  List only internal networks

--long

  List additional fields in output

--name <name>

  List only networks with the specified name

--enable

  List only enabled networks

--disable

  List only disabled networks

--project <project>

  List only networks with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--share

  List only networks shared between projects

--no-share

  List only networks not shared between projects

--status <status>

  List only networks with the specified status (‘ACTIVE’, ‘BUILD’, ‘DOWN’, ‘ERROR’)

--provider-network-type <provider-network-type>

  List only networks with the specified physical mechanisms. The supported options are: flat, geneve, gre, local, vlan and vxlan.

--provider-physical-network <provider-physical-network>

  List only networks with the specified physical network name

--provider-segment <provider-segment>

  List only networks with the specified provider segment ID (VLAN ID for VLAN networks or Tunnel ID for GENEVE/GRE/VXLAN networks)

--agent <agent-id>

  List only networks hosted the specified agent (ID only)

--tags <tag>[,<tag>,...]

  List networks which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List networks which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude networks which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude networks which have any given tag(s) (Comma-separated list of tags)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### network set

Set network properties

    openstack network set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--enable | --disable]
        [--share
        |
        --no-share
        ]
        [--description <description>]
        [--mtu <mtu>]
        [--enable-port-security
        |
        --disable-port-security
        ]
        [--external
        |
        --internal
        ]
        [--default | --no-default]
        [--qos-policy <qos-policy> | --no-qos-policy]
        [--pvlan | --no-pvlan]
        [--tag <tag>]
        [--no-tag]
        [--provider-network-type <provider-network-type>]
        [--provider-physical-network <provider-physical-network>]
        [--provider-segment <provider-segment>]
        [--dns-domain <dns-domain>]
        <network>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Set network name

--enable

  Enable network

--disable

  Disable network

--share

  Share the network between projects

--no-share

  Do not share the network between projects

--description <description>

  Set network description

--mtu <mtu>

  Set network mtu

--enable-port-security

  Enable port security by default for ports created on this network

--disable-port-security

  Disable port security by default for ports created on this network

--external

  The network has an external routing facility that is not managed by Neutron and can be used. For example: openstack router set –external-gateway NETWORK (external-net extension required).

--internal

  Opposite of ‘–external’

--default

  Set the network as the default external network

--no-default

  Do not use the network as the default external network

--qos-policy <qos-policy>

  QoS policy to attach to this network (name or ID)

--no-qos-policy

  Remove the QoS policy attached to this network

--pvlan

  Enable Private VLAN for the network. PVLAN extension required.

--no-pvlan

  Disable Private VLAN for the network (Default). PVLAN extension required.

--tag <tag>

  Tag to be added to the network (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the network. Specify both –tag and –no-tag to overwrite current tags

--provider-network-type <provider-network-type>

  The physical mechanism by which the virtual network is implemented. For example: flat, geneve, gre, local, vlan or vxlan.

--provider-physical-network <provider-physical-network>

  Name of the physical network over which the virtual network is implemented

--provider-segment <provider-segment>

  VLAN ID for VLAN networks or Tunnel ID for GENEVE/GRE/VXLAN networks

--dns-domain <dns-domain>

  Set DNS domain for this network (requires DNS integration extension)

network

  Network to modify (name or ID)

### network show

Show network details

    openstack network show <network>

network

  Network to display (name or ID)

### network unset

Unset network properties

    openstack network unset
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--tag <tag> | --all-tag]
        <network>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--tag <tag>

  Tag to be removed from the network (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the network

network

  Network to modify (name or ID)

## port

A port is a connection point for attaching a single device, such as the NIC of a server, to a network. The port also describes the associated network configuration, such as the MAC and IP addresses to be used on that port.

### port create

Create a new port

    openstack port create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        --network <network>
        [--description <description>]
        [--device <device-id>]
        [--mac-address <mac-address>]
        [--device-owner <device-owner>]
        [--vnic-type <vnic-type>]
        [--host <host-id>]
        [--dns-domain dns-domain]
        [--dns-name <dns-name>]
        [--numa-policy-required
        |
        --numa-policy-preferred
        |
        --numa-policy-socket
        |
        --numa-policy-legacy
        ]
        [--hint <alias=value>]
        [--trusted | --not-trusted]
        [--pvlan-type <type>]
        [--pvlan-community <community>]
        [--fixed-ip
        subnet=<subnet>,ip-address=<ip-address>
        |
        --no-fixed-ip
        ]
        [--binding-profile <binding-profile>]
        [--enable
        |
        --disable
        ]
        [--enable-uplink-status-propagation
        |
        --disable-uplink-status-propagation
        ]
        [--project <project>]
        [--project-domain <project-domain>]
        [--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]]
        [--security-group
        <security-group>
        |
        --no-security-group
        ]
        [--qos-policy <qos-policy>]
        [--enable-port-security
        |
        --disable-port-security
        ]
        [--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]]
        [--device-profile <device-profile>]
        [--hardware-offload-type <hardware-offload-type>]
        [--tag <tag> | --no-tag]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--network <network>

  Network this port belongs to (name or ID)

--description <description>

  Description of this port

--device <device-id>

  Port device ID

--mac-address <mac-address>

  MAC address of this port

--device-owner <device-owner>

  Device owner of this port. This is the entity that uses the port (for example, network:dhcp).

--vnic-type <vnic-type>

  VNIC type for this port (direct | direct-physical | macvtap | normal | baremetal | virtio-forwarder | vdpa | remote-managed) (default: normal)

--host <host-id>

  Allocate port on host <host-id> (ID only)

--dns-domain dns-domain

  Set DNS domain to this port (requires dns_domain extension for ports)

--dns-name <dns-name>

  Set DNS name for this port (requires DNS integration extension)

--numa-policy-required

  NUMA affinity policy required to schedule this port

--numa-policy-preferred

  NUMA affinity policy preferred to schedule this port

--numa-policy-socket

  NUMA affinity policy socket to schedule this port

--numa-policy-legacy

  NUMA affinity policy using legacy mode to schedule this port

--hint <alias=value>

  Port hints as ALIAS=VALUE or as JSON. Valid hint aliases/values: ovs-tx-steering=thread, ovs-tx-steering=hash. Valid JSON values are as specified by the Neutron API. (requires port-hints extension) (requires port-hint-ovs-tx-steering extension for alias: ovs-tx-steering) (repeat option to set multiple hints).

--trusted

  Set port to be trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--not-trusted

  Set port to be not trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--pvlan-type <type>

  Set Private VLAN type for this port. Requires PVLAN service plugin. Default: promiscuous.

--pvlan-community <community>

  Set PVLAN community name for this port. Only applies when pvlan-type is ‘community’. Requires PVLAN service plugin. Default: None.

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet for this port (name or ID): subnet=<subnet>,ip-address=<ip-address> (repeat option to set multiple fixed IP addresses)

--no-fixed-ip

  No IP or subnet set for this port

--binding-profile <binding-profile>

  Custom data to be passed as binding:profile. Data may be passed as <key>=<value> or JSON (repeat option to set multiple binding:profile data).

--enable

  Enable port (default)

--disable

  Disable port

--enable-uplink-status-propagation

  Enable uplink status propagation (default)

--disable-uplink-status-propagation

  Disable uplink status propagation

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]

  Extra DHCP options to be assigned to this port: name=<name>[,value=<value>,ip-version={4,6}] (repeat option to set multiple extra DHCP options)

--security-group <security-group>

  Security group to associate with this port (name or ID) (repeat option to set multiple security groups)

--no-security-group

  Associate no security groups with this port

--qos-policy <qos-policy>

  Attach QoS policy to this port (name or ID)

--enable-port-security

  Enable port security for this port (default)

--disable-port-security

  Disable port security for this port

--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]

  Add allowed-address pair associated with this port: ip-address=<ip-address>[,mac-address=<mac-address>] (repeat option to set multiple allowed-address pairs)

--device-profile <device-profile>

  Port device profile

--hardware-offload-type <hardware-offload-type>

  Hardware offload type this port will request when attached to the network backend

--tag <tag>

  Tag to be added to the port (repeat option to set multiple tags)

--no-tag

  No tags associated with the port

name

  Name of this port

### port delete

Delete port(s)

    openstack port delete <port> [<port> ...]

port

  Port(s) to delete (name or ID)

### port list

List ports

    openstack port list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--device-owner <device-owner>]
        [--host <host-id>]
        [--network <network>]
        [--router
        <router>
        |
        --server <server>
        |
        --device-id <device-id>
        ]
        [--mac-address <mac-address>]
        [--long]
        [--project <project>]
        [--name <name>]
        [--security-group <security-group>]
        [--status <status>]
        [--project-domain <project-domain>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>,ip-substring=<ip-substring>]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--device-owner <device-owner>

  List only ports with the specified device owner. This is the entity that uses the port (for example, network:dhcp).

--host <host-id>

  List only ports bound to this host ID

--network <network>

  List only ports connected to this network (name or ID)

--router <router>

  List only ports attached to this router (name or ID)

--server <server>

  List only ports attached to this server (name or ID)

--device-id <device-id>

  List only ports with the specified device ID

--mac-address <mac-address>

  List only ports with the specified MAC address

--long

  List additional fields in output

--project <project>

  List only ports with the specified project (name or ID)

--name <name>

  List only ports with the specified name

--security-group <security-group>

  List only ports associated with this security group

--status <status>

  List only ports with the specified status (‘ACTIVE’, ‘BUILD’, ‘DOWN’, ‘ERROR’)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--fixed-ip subnet=<subnet>,ip-address=<ip-address>,ip-substring=<ip-substring>

  Desired IP and/or subnet for filtering ports (name or ID): subnet=<subnet>,ip-address=<ip-address>,ip-substring=<ip-substring> (repeat option to filter multiple fixed IP addresses)

--tags <tag>[,<tag>,...]

  List ports which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List ports which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude ports which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude ports which have any given tag(s) (Comma-separated list of tags)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### port set

Set port properties

    openstack port set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--device <device-id>]
        [--mac-address <mac-address>]
        [--device-owner <device-owner>]
        [--vnic-type <vnic-type>]
        [--host <host-id>]
        [--dns-domain dns-domain]
        [--dns-name <dns-name>]
        [--numa-policy-required
        |
        --numa-policy-preferred
        |
        --numa-policy-socket
        |
        --numa-policy-legacy
        ]
        [--hint <alias=value>]
        [--trusted | --not-trusted]
        [--pvlan-type <type>]
        [--pvlan-community <community>]
        [--enable
        |
        --disable
        ]
        [--name <name>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        [--no-fixed-ip]
        [--binding-profile <binding-profile>]
        [--no-binding-profile]
        [--qos-policy <qos-policy>]
        [--security-group <security-group>]
        [--no-security-group]
        [--enable-port-security
        |
        --disable-port-security
        ]
        [--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]]
        [--no-allowed-address]
        [--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]]
        [--data-plane-status <status>]
        [--enable-uplink-status-propagation
        |
        --disable-uplink-status-propagation
        ]
        [--tag <tag>]
        [--no-tag]
        <port>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Description of this port

--device <device-id>

  Port device ID

--mac-address <mac-address>

  MAC address of this port (admin only)

--device-owner <device-owner>

  Device owner of this port. This is the entity that uses the port (for example, network:dhcp).

--vnic-type <vnic-type>

  VNIC type for this port (direct | direct-physical | macvtap | normal | baremetal | virtio-forwarder | vdpa | remote-managed) (default: normal)

--host <host-id>

  Allocate port on host <host-id> (ID only)

--dns-domain dns-domain

  Set DNS domain to this port (requires dns_domain extension for ports)

--dns-name <dns-name>

  Set DNS name for this port (requires DNS integration extension)

--numa-policy-required

  NUMA affinity policy required to schedule this port

--numa-policy-preferred

  NUMA affinity policy preferred to schedule this port

--numa-policy-socket

  NUMA affinity policy socket to schedule this port

--numa-policy-legacy

  NUMA affinity policy using legacy mode to schedule this port

--hint <alias=value>

  Port hints as ALIAS=VALUE or as JSON. Valid hint aliases/values: ovs-tx-steering=thread, ovs-tx-steering=hash. Valid JSON values are as specified by the Neutron API. (requires port-hints extension) (requires port-hint-ovs-tx-steering extension for alias: ovs-tx-steering) (repeat option to set multiple hints).

--trusted

  Set port to be trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--not-trusted

  Set port to be not trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--pvlan-type <type>

  Set Private VLAN type for this port. Requires PVLAN service plugin. Default: promiscuous.

--pvlan-community <community>

  Set PVLAN community name for this port. Only applies when pvlan-type is ‘community’. Requires PVLAN service plugin. Default: None.

--enable

  Enable port

--disable

  Disable port

--name <name>

  Set port name

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet for this port (name or ID): subnet=<subnet>,ip-address=<ip-address> (repeat option to set multiple fixed IP addresses)

--no-fixed-ip

  Clear existing information of fixed IP addresses. Specify both –fixed-ip and –no-fixed-ip to overwrite the current fixed IP addresses.

--binding-profile <binding-profile>

  Custom data to be passed as binding:profile. Data may be passed as <key>=<value> or JSON (repeat option to set multiple binding:profile data).

--no-binding-profile

  Clear existing information of binding:profile. Specify both –binding-profile and –no-binding-profile to overwrite the current binding:profile information.

--qos-policy <qos-policy>

  Attach QoS policy to this port (name or ID)

--security-group <security-group>

  Security group to associate with this port (name or ID) (repeat option to set multiple security groups)

--no-security-group

  Clear existing security groups associated with this port

--enable-port-security

  Enable port security for this port

--disable-port-security

  Disable port security for this port

--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]

  Add allowed-address pair associated with this port: ip-address=<ip-address>[,mac-address=<mac-address>] (repeat option to set multiple allowed-address pairs)

--no-allowed-address

  Clear existing allowed-address pairs associated with this port. Specify both –allowed-address and –no-allowed-address to overwrite the current allowed-address pairs.

--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]

  Extra DHCP options to be assigned to this port: name=<name>[,value=<value>,ip-version={4,6}] (repeat option to set multiple extra DHCP options)

--data-plane-status <status>

  Set data plane status of this port (ACTIVE | DOWN). Unset it to None with the ‘port unset’ command (requires data plane status extension).

--enable-uplink-status-propagation

  Enable uplink status propagation

--disable-uplink-status-propagation

  Disable uplink status propagation

--tag <tag>

  Tag to be added to the port (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the port. Specify both –tag and –no-tag to overwrite current tags

port

  Port to modify (name or ID)

### port show

Display port details

    openstack port show <port>

port

  Port to display (name or ID)

### port unset

Unset port properties

    openstack port unset
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        [--binding-profile <binding-profile-key>]
        [--security-group <security-group>]
        [--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]]
        [--qos-policy]
        [--data-plane-status]
        [--numa-policy]
        [--host]
        [--hints]
        [--device]
        [--device-owner]
        [--pvlan-community]
        [--tag <tag> | --all-tag]
        <port>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet which should be removed from this port (name or ID): subnet=<subnet>,ip-address=<ip-address> (repeat option to unset multiple fixed IP addresses)

--binding-profile <binding-profile-key>

  Desired key which should be removed from binding:profile (repeat option to unset multiple binding:profile keys)

--security-group <security-group>

  Security group which should be removed this port (name or ID) (repeat option to unset multiple security groups)

--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]

  Desired allowed-address pair which should be removed from this port: ip-address=<ip-address>[,mac-address=<mac-address>] (repeat option to unset multiple allowed-address pairs)

--qos-policy

  Remove the QoS policy attached to the port

--data-plane-status

  Clear existing data plane status information

--numa-policy

  Clear existing NUMA affinity policy

--host

  Clear host binding for the port

--hints

  Clear hints for the port

--device

  Clear device ID for the port.

--device-owner

  Clear device owner for the port.

--pvlan-community

  Clear PVLAN community name for the port.

--tag <tag>

  Tag to be removed from the port (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the port

port

  Port to modify (name or ID)

## router ndp proxy

An NDP proxy publishes a internal IPv6 address to public network. With the NDP proxy, the IPv6 address can be accessed from external. It is similar to Floating IP of IPv4 in functionality.

### router ndp proxy create

Create NDP proxy

    openstack router ndp proxy create
        [--name <name>]
        --port <port>
        [--ip-address <ip-address>]
        [--description <description>]
        <router>

--name <name>

  New NDP proxy name

--port <port>

  The name or ID of the network port associated to the NDP proxy

--ip-address <ip-address>

  The IPv6 address that is to be proxied. In case the port has multiple addresses assigned, use this option to select which address is to be used.

--description <description>

  Text to describe/contextualize the use of the NDP proxy configuration

router

  The name or ID of a router

### router ndp proxy delete

Delete NDP proxy

    openstack router ndp proxy delete <ndp-proxy> [<ndp-proxy> ...]

ndp-proxy

  NDP proxy(s) to delete (name or ID)

### router ndp proxy list

List NDP proxies

    openstack router ndp proxy list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--router <router>]
        [--port <port>]
        [--ip-address <ip-address>]
        [--project <project>]
        [--name <name>]
        [--project-domain <project-domain>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--router <router>

  List only NDP proxies associated with the specifed router (name or ID)

--port <port>

  List only NDP proxies associated with the specified port (name or ID)

--ip-address <ip-address>

  List only NDP proxies associated with the specified IPv6 address

--project <project>

  List only NDP proxies with the specified project (name or ID)

--name <name>

  List only NDP proxies with the specified name

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

### router ndp proxy set

Set NDP proxy properties

    openstack router ndp proxy set
        [--name <name>]
        [--description <description>]
        <ndp-proxy>

--name <name>

  Set NDP proxy name

--description <description>

  Text to describe/contextualize the use of the NDP proxy configuration

ndp-proxy

  The ID or name of the NDP proxy to update

### router ndp proxy show

Display NDP proxy details

    openstack router ndp proxy show <ndp-proxy>

ndp-proxy

  The ID or name of the NDP proxy

## router

A router is a logical component that forwards data packets between networks. It also provides Layer 3 and NAT forwarding to provide external network access for servers on project networks.

### router add gateway

Add router gateway

    openstack router add gateway
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        <router>
        <network>

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet (name or ID) on external gateway: subnet=<subnet>,ip-address=<ip-address> (repeat option to set multiple fixed IP addresses)

router

  Router to modify (name or ID)

network

  External Network to a attach a router gateway to (name or ID)

### router add port

Add a port to a router

    openstack router add port <router> <port>

router

  Router to which port will be added (name or ID)

port

  Port to be added (name or ID)

### router add route

Add extra static routes to a router’s routing table.

    openstack router add route
        [--route destination=<subnet>,gateway=<ip-address>]
        <router>

--route destination=<subnet>,gateway=<ip-address>

  Add extra static route to the router. destination: destination subnet (in CIDR notation), gateway: nexthop IP address. Repeat option to add multiple routes. Trying to add a route that is already present (exactly, including destination and nexthop) in the routing table is allowed and is considered a successful operation.

router

  Router to which extra static routes will be added (name or ID)

### router add subnet

Add a subnet to a router

    openstack router add subnet [--advertise-host] <router> <subnet>

--advertise-host

  Mark the subnet’s prefixes to be advertised as host routes within the router’s EVPN VNI. Only valid for EVPN routers.

router

  Router to which subnet will be added (name or ID)

subnet

  Subnet to be added (name or ID)

### router create

Create a new router

    openstack router create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--enable | --disable]
        [--distributed
        |
        --centralized
        ]
        [--ha | --no-ha]
        [--description <description>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--availability-zone-hint <availability-zone>]
        [--tag <tag> | --no-tag]
        [--external-gateway <network>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        [--enable-snat | --disable-snat]
        [--enable-ndp-proxy | --disable-ndp-proxy]
        [--flavor <flavor-id>]
        [--enable-default-route-bfd]
        [--disable-default-route-bfd]
        [--enable-default-route-ecmp]
        [--disable-default-route-ecmp]
        [--qos-policy <qos-policy>]
        [--evpn-vni
        <vni>
        |
        --auto-evpn-vni
        ]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--enable

  Enable router (default)

--disable

  Disable router

--distributed

  Create a distributed router

--centralized

  Create a centralized router

--ha

  Create a highly available router

--no-ha

  Create a legacy router

--description <description>

  Set router description

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--availability-zone-hint <availability-zone>

  Availability Zone in which to create this router (Router Availability Zone extension required, repeat option to set multiple availability zones)

--tag <tag>

  Tag to be added to the router (repeat option to set multiple tags)

--no-tag

  No tags associated with the router

--external-gateway <network>

  External Network used as router’s gateway (name or ID) (repeat option to set multiple gateways per router if the L3 service plugin in use supports it)

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet (name or ID) on external gateway: subnet=<subnet>,ip-address=<ip-address> (repeat option to set multiple fixed IP addresses)

--enable-snat

  Enable Source NAT on external gateway

--disable-snat

  Disable Source NAT on external gateway

--enable-ndp-proxy

  Enable IPv6 NDP proxy on external gateway

--disable-ndp-proxy

  Disable IPv6 NDP proxy on external gateway

--flavor <flavor-id>

  Associate the router to a flavor (by name or ID

--enable-default-route-bfd

  Enable BFD sessions for default routes inferred from the external gateway port subnets for this router

--disable-default-route-bfd

  Disable BFD sessions for default routes inferred from the external gateway port subnets for this router

--enable-default-route-ecmp

  Add ECMP default routes if multiple are available via different gateway ports

--disable-default-route-ecmp

  Add default route only for first gateway port

--qos-policy <qos-policy>

  Attach QoS policy to router gateway IPs

--evpn-vni <vni>

  Associate the router with an EVPN identified by a VNI.

--auto-evpn-vni

  Associate the router with an EVPN using an auto-assigned VNI.

name

  New router name

### router delete

Delete router(s)

    openstack router delete <router> [<router> ...]

router

  Router(s) to delete (name or ID)

### router list

List routers

    openstack router list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--name <name>]
        [--enable
        |
        --disable
        ]
        [--long]
        [--project <project>]
        [--project-domain <project-domain>]
        [--agent <agent-id>]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--name <name>

  List routers according to their name

--enable

  List enabled routers

--disable

  List disabled routers

--long

  List additional fields in output

--project <project>

  List only routers with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--agent <agent-id>

  List only routers hosted by the specified agent (ID only)

--tags <tag>[,<tag>,...]

  List routers which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List routers which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude routers which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude routers which have any given tag(s) (Comma-separated list of tags)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### router ndp proxy create

Create NDP proxy

    openstack router ndp proxy create
        [--name <name>]
        --port <port>
        [--ip-address <ip-address>]
        [--description <description>]
        <router>

--name <name>

  New NDP proxy name

--port <port>

  The name or ID of the network port associated to the NDP proxy

--ip-address <ip-address>

  The IPv6 address that is to be proxied. In case the port has multiple addresses assigned, use this option to select which address is to be used.

--description <description>

  Text to describe/contextualize the use of the NDP proxy configuration

router

  The name or ID of a router

### router ndp proxy delete

Delete NDP proxy

    openstack router ndp proxy delete <ndp-proxy> [<ndp-proxy> ...]

ndp-proxy

  NDP proxy(s) to delete (name or ID)

### router ndp proxy list

List NDP proxies

    openstack router ndp proxy list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--router <router>]
        [--port <port>]
        [--ip-address <ip-address>]
        [--project <project>]
        [--name <name>]
        [--project-domain <project-domain>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--router <router>

  List only NDP proxies associated with the specifed router (name or ID)

--port <port>

  List only NDP proxies associated with the specified port (name or ID)

--ip-address <ip-address>

  List only NDP proxies associated with the specified IPv6 address

--project <project>

  List only NDP proxies with the specified project (name or ID)

--name <name>

  List only NDP proxies with the specified name

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

### router ndp proxy set

Set NDP proxy properties

    openstack router ndp proxy set
        [--name <name>]
        [--description <description>]
        <ndp-proxy>

--name <name>

  Set NDP proxy name

--description <description>

  Text to describe/contextualize the use of the NDP proxy configuration

ndp-proxy

  The ID or name of the NDP proxy to update

### router ndp proxy show

Display NDP proxy details

    openstack router ndp proxy show <ndp-proxy>

ndp-proxy

  The ID or name of the NDP proxy

### router remove gateway

Remove router gateway

    openstack router remove gateway
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        <router>
        <network>

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  IP and/or subnet (name or ID) on the external gateway which is used to identify a particular gateway if multiple are attached to the same network: subnet=<subnet>,ip-address=<ip-address>

router

  Router to modify (name or ID).

network

  External Network to remove a router gateway from (name or ID)

### router remove port

Remove a port from a router

    openstack router remove port <router> <port>

router

  Router from which port will be removed (name or ID)

port

  Port to be removed and deleted (name or ID)

### router remove route

Remove extra static routes from a router’s routing table.

    openstack router remove route
        [--route destination=<subnet>,gateway=<ip-address>]
        <router>

--route destination=<subnet>,gateway=<ip-address>

  Remove extra static route from the router. destination: destination subnet (in CIDR notation), gateway: nexthop IP address. Repeat option to remove multiple routes. Trying to remove a route that is already missing (fully, including destination and nexthop) from the routing table is allowed and is considered a successful operation.

router

  Router from which extra static routes will be removed (name or ID)

### router remove subnet

Remove a subnet from a router

    openstack router remove subnet <router> <subnet>

router

  Router from which the subnet will be removed (name or ID)

subnet

  Subnet to be removed (name or ID)

### router set

Set router properties

    openstack router set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--description <description>]
        [--enable | --disable]
        [--distributed
        |
        --centralized
        ]
        [--route destination=<subnet>,gateway=<ip-address>]
        [--no-route]
        [--ha | --no-ha]
        [--external-gateway <network>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        [--enable-snat | --disable-snat]
        [--enable-ndp-proxy | --disable-ndp-proxy]
        [--qos-policy <qos-policy> | --no-qos-policy]
        [--tag <tag>]
        [--no-tag]
        [--enable-default-route-bfd]
        [--disable-default-route-bfd]
        [--enable-default-route-ecmp]
        [--disable-default-route-ecmp]
        <router>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Set router name

--description <description>

  Set router description

--enable

  Enable router

--disable

  Disable router

--distributed

  Set router to distributed mode (disabled router only)

--centralized

  Set router to centralized mode (disabled router only)

--route destination=<subnet>,gateway=<ip-address>

  Add routes to the router. destination: destination subnet (in CIDR notation) gateway: nexthop IP address (repeat option to add multiple routes). This is deprecated in favor of ‘router add/remove route’ since it is prone to race conditions between concurrent clients when not used together with –no-route to overwrite the current value of ‘routes’.

--no-route

  Clear routes associated with the router. Specify both –route and –no-route to overwrite current value of routes.

--ha

  Set the router as highly available (disabled router only)

--no-ha

  Clear high availability attribute of the router (disabled router only)

--external-gateway <network>

  External Network used as router’s gateway (name or ID) (repeat option to set multiple gateways per router if the L3 service plugin in use supports it).

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet (name or ID) on external gateway: subnet=<subnet>,ip-address=<ip-address> (repeat option to set multiple fixed IP addresses)

--enable-snat

  Enable Source NAT on external gateway

--disable-snat

  Disable Source NAT on external gateway

--enable-ndp-proxy

  Enable IPv6 NDP proxy on external gateway

--disable-ndp-proxy

  Disable IPv6 NDP proxy on external gateway

--qos-policy <qos-policy>

  Attach QoS policy to router gateway IPs

--no-qos-policy

  Remove QoS policy from router gateway IPs

--tag <tag>

  Tag to be added to the router (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the router. Specify both –tag and –no-tag to overwrite current tags

--enable-default-route-bfd

  Enable BFD sessions for default routes inferred from the external gateway port subnets for this router

--disable-default-route-bfd

  Disable BFD sessions for default routes inferred from the external gateway port subnets for this router

--enable-default-route-ecmp

  Add ECMP default routes if multiple are available via different gateway ports

--disable-default-route-ecmp

  Add default route only for first gateway port

router

  Router to modify (name or ID)

### router show

Display router details

    openstack router show <router>

router

  Router to display (name or ID)

### router unset

Unset router properties

    openstack router unset
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--route destination=<subnet>,gateway=<ip-address>]
        [--external-gateway]
        [--qos-policy]
        [--tag <tag> | --all-tag]
        <router>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--route destination=<subnet>,gateway=<ip-address>

  Routes to be removed from the router. destination: destination subnet (in CIDR notation) gateway: nexthop IP address (repeat option to unset multiple routes)

--external-gateway

  Remove external gateway information from the router

--qos-policy

  Remove QoS policy from router gateway IPs

--tag <tag>

  Tag to be removed from the router (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the router

router

  Router to modify (name or ID)

## security group default statefulness

### security group default statefulness create

Create a default statefulness setting for security groups

    openstack security group default statefulness create
        (--stateful | --stateless)
        [--project <project>]
        [--project-domain <project-domain>]

--stateful

  Set default statefulness to stateful

--stateless

  Set default statefulness to stateless

--project <project>

  Apply the setting to this project (name or ID). If not specified, the setting applies system-wide

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

### security group default statefulness delete

Delete security group default statefulness setting(s)

    openstack security group default statefulness delete
        <setting>
        [<setting> ...]

setting

  Default statefulness setting(s) to delete (ID only)

### security group default statefulness list

List security group default statefulness settings

    openstack security group default statefulness list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--project <project>]
        [--project-domain <project-domain>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--project <project>

  List only settings for this project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

### security group default statefulness set

Update a security group default statefulness setting

    openstack security group default statefulness set
        (--stateful
        |
        --stateless
        )
        <setting>

--stateful

  Set default statefulness to stateful

--stateless

  Set default statefulness to stateless

setting

  Default statefulness setting to modify (ID only)

### security group default statefulness show

Show a security group default statefulness setting

    openstack security group default statefulness show <setting>

setting

  Default statefulness setting to display (ID only)

## security group rule

A security group rule specifies the network access rules for servers and other resources on the network.

### security group rule create

Create a new security group rule

    openstack security group rule create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--remote-ip
        <ip-address>
        |
        --remote-group <group>
        |
        --remote-address-group <group>
        ]
        [--dst-port <port-range>]
        [--protocol <protocol>]
        [--description <description>]
        [--icmp-type <icmp-type>]
        [--icmp-code <icmp-code>]
        [--ingress | --egress]
        [--ethertype <ethertype>]
        [--project <project>]
        [--project-domain <project-domain>]
        <group>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--remote-ip <ip-address>

  Remote IP address block (may use CIDR notation; default for IPv4 rule: 0.0.0.0/0, default for IPv6 rule: ::/0)

--remote-group <group>

  Remote security group (name or ID)

--remote-address-group <group>

  Remote address group (name or ID)

--dst-port <port-range>

  Destination port, may be a single port or a starting and ending port range: 137:139. Required for IP protocols TCP and UDP. Ignored for ICMP IP protocols.

--protocol <protocol>

  IP protocol (ah, dccp, egp, esp, gre, icmp, igmp, ipv6-encap, ipv6-frag, ipv6-icmp, ipv6-nonxt, ipv6-opts, ipv6-route, ospf, pgm, rsvp, sctp, tcp, udp, udplite, vrrp and integer representations [0-255] or any; default: any (all protocols))

--description <description>

  Set security group rule description

--icmp-type <icmp-type>

  ICMP type for ICMP IP protocols

--icmp-code <icmp-code>

  ICMP code for ICMP IP protocols

--ingress

  Rule applies to incoming network traffic (default)

--egress

  Rule applies to outgoing network traffic

--ethertype <ethertype>

  Ethertype of network traffic (IPv4, IPv6; default: based on IP protocol)

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

group

  Create rule in this security group (name or ID)

### security group rule delete

Delete security group rule(s)

    openstack security group rule delete <rule> [<rule> ...]

rule

  Security group rule(s) to delete (ID only)

### security group rule list

List security group rules

    openstack security group rule list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--protocol <protocol>]
        [--ethertype <ethertype>]
        [--ingress | --egress]
        [--long]
        [--project <project>]
        [--project-domain <project-domain>]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]
        [<group>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--protocol <protocol>

  List only rules with the specified IP protocol (ah, dhcp, egp, esp, gre, icmp, igmp, ipv6-encap, ipv6-frag, ipv6-icmp, ipv6-nonxt, ipv6-opts, ipv6-route, ospf, pgm, rsvp, sctp, tcp, udp, udplite, vrrp and integer representations [0-255] or any; default: any (all protocols))

--ethertype <ethertype>

  List only rules with the specified Ethertype (IPv4 or IPv6)

--ingress

  List only rules applied to incoming network traffic

--egress

  List only rules applied to outgoing network traffic

--long

  Deprecated This argument is no longer needed

--project <project>

  List only rules with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

group

  List all rules in this security group (name or ID)

### security group rule show

Display security group rule details

    openstack security group rule show <rule>

rule

  Security group rule to display (ID only)

## security group

A security group acts as a virtual firewall for servers and other resources on a network. It is a container for security group rules which specify the network access rules.

### security group create

Create a new security group

    openstack security group create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--project <project>]
        [--stateful
        |
        --stateless
        ]
        [--project-domain <project-domain>]
        [--tag <tag> | --no-tag]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Security group description

--project <project>

  Owner’s project (name or ID)

--stateful

  Security group is stateful (default)

--stateless

  Security group is stateless

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--tag <tag>

  Tag to be added to the security group (repeat option to set multiple tags)

--no-tag

  No tags associated with the security group

name

  New security group name

### security group delete

Delete security group(s)

    openstack security group delete <group> [<group> ...]

group

  Security group(s) to delete (name or ID)

### security group list

List security groups

    openstack security group list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--project <project>]
        [--project-domain <project-domain>]
        [--share | --no-share]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--project <project>

  List only security groups with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--share

  List only security groups shared between projects

--no-share

  List only security groups not shared between projects

--tags <tag>[,<tag>,...]

  List security group which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List security group which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude security group which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude security group which have any given tag(s) (Comma-separated list of tags)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### security group set

Set security group properties

    openstack security group set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <new-name>]
        [--description <description>]
        [--stateful | --stateless]
        [--tag <tag>]
        [--no-tag]
        <group>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <new-name>

  New security group name

--description <description>

  New security group description

--stateful

  Security group is stateful (default)

--stateless

  Security group is stateless

--tag <tag>

  Tag to be added to the security group (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the security group. Specify both –tag and –no-tag to overwrite current tags

group

  Security group to modify (name or ID)

### security group show

Display security group details

    openstack security group show <group>

group

  Security group to display (name or ID)

### security group unset

Unset security group properties

    openstack security group unset [--tag <tag> | --all-tag] <group>

--tag <tag>

  Tag to be removed from the security group (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the security group

group

  Security group to modify (name or ID)

## subnet pool

A subnet pool contains a collection of prefixes in CIDR notation that are available for IP address allocation.

### subnet pool create

Create subnet pool

    openstack subnet pool create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        --pool-prefix <pool-prefix>
        [--default-prefix-length <default-prefix-length>]
        [--min-prefix-length <min-prefix-length>]
        [--max-prefix-length <max-prefix-length>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--address-scope <address-scope>]
        [--default | --no-default]
        [--share
        |
        --no-share
        ]
        [--description <description>]
        [--default-quota <num-ip-addresses>]
        [--tag <tag> | --no-tag]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--pool-prefix <pool-prefix>

  Set subnet pool prefixes (in CIDR notation) (repeat option to set multiple prefixes)

--default-prefix-length <default-prefix-length>

  Set subnet pool default prefix length

--min-prefix-length <min-prefix-length>

  Set subnet pool minimum prefix length

--max-prefix-length <max-prefix-length>

  Set subnet pool maximum prefix length

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--address-scope <address-scope>

  Set address scope associated with the subnet pool (name or ID), prefixes must be unique across address scopes

--default

  Set this as a default subnet pool

--no-default

  Set this as a non-default subnet pool

--share

  Set this subnet pool as shared

--no-share

  Set this subnet pool as not shared

--description <description>

  Set subnet pool description

--default-quota <num-ip-addresses>

  Set default per-project quota for this subnet pool as the number of IP addresses that can be allocated from the subnet pool

--tag <tag>

  Tag to be added to the subnet pool (repeat option to set multiple tags)

--no-tag

  No tags associated with the subnet pool

name

  Name of the new subnet pool

### subnet pool delete

Delete subnet pool(s)

    openstack subnet pool delete <subnet-pool> [<subnet-pool> ...]

subnet-pool

  Subnet pool(s) to delete (name or ID)

### subnet pool list

List subnet pools

    openstack subnet pool list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--long]
        [--share | --no-share]
        [--default
        |
        --no-default
        ]
        [--project <project>]
        [--project-domain <project-domain>]
        [--name <name>]
        [--address-scope <address-scope>]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--long

  List additional fields in output

--share

  List only subnet pools shared between projects

--no-share

  List only subnet pools not shared between projects

--default

  List only subnet pools used as the default external subnet pool

--no-default

  List only subnet pools not used as the default external subnet pool

--project <project>

  List only subnet pools with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--name <name>

  List only subnet pools with the specified name

--address-scope <address-scope>

  List only subnet pools with the specified address scope (name or ID)

--tags <tag>[,<tag>,...]

  List subnet pools which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List subnet pools which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude subnet pools which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude subnet pools which have any given tag(s) (Comma-separated list of tags)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### subnet pool set

Set subnet pool properties

    openstack subnet pool set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--pool-prefix <pool-prefix>]
        [--default-prefix-length <default-prefix-length>]
        [--min-prefix-length <min-prefix-length>]
        [--max-prefix-length <max-prefix-length>]
        [--address-scope
        <address-scope>
        |
        --no-address-scope
        ]
        [--default
        |
        --no-default
        ]
        [--description <description>]
        [--default-quota <num-ip-addresses>]
        [--tag <tag>]
        [--no-tag]
        <subnet-pool>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Set subnet pool name

--pool-prefix <pool-prefix>

  Set subnet pool prefixes (in CIDR notation) (repeat option to set multiple prefixes)

--default-prefix-length <default-prefix-length>

  Set subnet pool default prefix length

--min-prefix-length <min-prefix-length>

  Set subnet pool minimum prefix length

--max-prefix-length <max-prefix-length>

  Set subnet pool maximum prefix length

--address-scope <address-scope>

  Set address scope associated with the subnet pool (name or ID), prefixes must be unique across address scopes

--no-address-scope

  Remove address scope associated with the subnet pool

--default

  Set this as a default subnet pool

--no-default

  Set this as a non-default subnet pool

--description <description>

  Set subnet pool description

--default-quota <num-ip-addresses>

  Set default per-project quota for this subnet pool as the number of IP addresses that can be allocated from the subnet pool

--tag <tag>

  Tag to be added to the subnet pool (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the subnet pool. Specify both –tag and –no-tag to overwrite current tags

subnet-pool

  Subnet pool to modify (name or ID)

### subnet pool show

Display subnet pool details

    openstack subnet pool show <subnet-pool>

subnet-pool

  Subnet pool to display (name or ID)

### subnet pool unset

Unset subnet pool properties

    openstack subnet pool unset [--tag <tag> | --all-tag] <subnet-pool>

--tag <tag>

  Tag to be removed from the subnet pool (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the subnet pool

subnet-pool

  Subnet pool to modify (name or ID)

## subnet

A subnet is a block of IP addresses and associated configuration state. Subnets are used to allocate IP addresses when new ports are created on a network.

### subnet create

Create a subnet

    openstack subnet create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--subnet-pool
        <subnet-pool>
        |
        --use-prefix-delegation
        |
        --use-default-subnet-pool
        ]
        [--prefix-length <prefix-length>]
        [--subnet-range <subnet-range>]
        [--dhcp
        |
        --no-dhcp
        ]
        [--dns-publish-fixed-ip
        |
        --no-dns-publish-fixed-ip
        ]
        [--gateway <gateway>]
        [--ip-version {4,6}]
        [--ipv6-ra-mode {dhcpv6-stateful,dhcpv6-stateless,slaac}]
        [--ipv6-address-mode {dhcpv6-stateful,dhcpv6-stateless,slaac}]
        [--network-segment <network-segment>]
        --network <network>
        [--description <description>]
        [--allocation-pool start=<ip-address>,end=<ip-address>]
        [--dns-nameserver <dns-nameserver>]
        [--host-route destination=<subnet>,gateway=<ip-address>]
        [--service-type <service-type>]
        [--tag
        <tag>
        |
        --no-tag
        ]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--subnet-pool <subnet-pool>

  Subnet pool from which this subnet will obtain a CIDR (Name or ID)

--use-prefix-delegation

  Use ‘prefix-delegation’ if IP is IPv6 format and IP would be delegated externally

--use-default-subnet-pool

  Use default subnet pool for –ip-version

--prefix-length <prefix-length>

  Prefix length for subnet allocation from subnet pool

--subnet-range <subnet-range>

  Subnet range in CIDR notation (required if –subnet-pool is not specified, optional otherwise)

--dhcp

  Enable DHCP (default)

--no-dhcp

  Disable DHCP

--dns-publish-fixed-ip

  Enable publishing fixed IPs in DNS

--no-dns-publish-fixed-ip

  Disable publishing fixed IPs in DNS (default)

--gateway <gateway>

  Specify a gateway for the subnet. The three options are: <ip-address>: Specific IP address to use as the gateway, ‘auto’: Gateway address should automatically be chosen from within the subnet itself, ‘none’: This subnet will not use a gateway. For example, –gateway 192.168.9.1, –gateway auto or –gateway none (default is ‘auto’).

--ip-version <IP_VERSION>

  IP version (default is 4). Note that when subnet pool is specified, IP version is determined from the subnet pool and this option is ignored.

--ipv6-ra-mode <IPV6_RA_MODE>

  IPv6 RA (Router Advertisement) mode, valid modes: [dhcpv6-stateful, dhcpv6-stateless, slaac]

--ipv6-address-mode <IPV6_ADDRESS_MODE>

  IPv6 address mode, valid modes: [dhcpv6-stateful, dhcpv6-stateless, slaac]

--network-segment <network-segment>

  Network segment to associate with this subnet (name or ID)

--network <network>

  Network this subnet belongs to (name or ID)

--description <description>

  Set subnet description

--allocation-pool start=<ip-address>,end=<ip-address>

  Allocation pool IP addresses for this subnet, for example, start=192.168.199.2,end=192.168.199.254 (repeat option to add multiple IP addresses)

--dns-nameserver <dns-nameserver>

  DNS server for this subnet (repeat option to set multiple DNS servers)

--host-route destination=<subnet>,gateway=<ip-address>

  Additional route for this subnet, for example, destination=10.10.0.0/16,gateway=192.168.71.254 destination: destination subnet (in CIDR notation) gateway: next-hop IP address (repeat option to add multiple routes)

--service-type <service-type>

  Service type for this subnet, for example, network:floatingip_agent_gateway. Must be a valid device owner value for a network port (repeat option to set multiple service types)

--tag <tag>

  Tag to be added to the subnet (repeat option to set multiple tags)

--no-tag

  No tags associated with the subnet

name

  New subnet name

### subnet delete

Delete subnet(s)

    openstack subnet delete <subnet> [<subnet> ...]

subnet

  Subnet(s) to delete (name or ID)

### subnet list

List subnets

    openstack subnet list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--long]
        [--ip-version <ip-version>]
        [--dhcp | --no-dhcp]
        [--service-type <service-type>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--network <network>]
        [--gateway <gateway>]
        [--name <name>]
        [--subnet-range <subnet-range>]
        [--subnet-pool <subnet-pool>]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--long

  List additional fields in output

--ip-version <ip-version>

  List only subnets with the specified IP version. Allowed values for IP version are 4 and 6.

--dhcp

  List only subnets which have DHCP enabled

--no-dhcp

  List only subnets which have DHCP disabled

--service-type <service-type>

  List only subnets with the specified service type, for example, network:floatingip_agent_gateway. Must be a valid device owner value for a network port (repeat option to list multiple service types).

--project <project>

  List only subnets with the specified project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--network <network>

  List only subnets which belong to the specified network (name or ID)

--gateway <gateway>

  List only subnets with the specified gateway IP

--name <name>

  List only subnets with the specified name

--subnet-range <subnet-range>

  List only subnets with the specified subnet range (in CIDR notation). For example, –subnet-range 10.10.0.0/16

--subnet-pool <subnet-pool>

  List only subnets which belong to the specified subnet pool (name or ID)

--tags <tag>[,<tag>,...]

  List subnets which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List subnets which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude subnets which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude subnets which have any given tag(s) (Comma-separated list of tags)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### subnet set

Set subnet properties

    openstack subnet set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--name <name>]
        [--dhcp | --no-dhcp]
        [--dns-publish-fixed-ip
        |
        --no-dns-publish-fixed-ip
        ]
        [--gateway <gateway>]
        [--network-segment <network-segment>]
        [--description <description>]
        [--tag <tag>]
        [--no-tag]
        [--allocation-pool start=<ip-address>,end=<ip-address>]
        [--no-allocation-pool]
        [--dns-nameserver <dns-nameserver>]
        [--no-dns-nameservers]
        [--host-route destination=<subnet>,gateway=<ip-address>]
        [--no-host-route]
        [--service-type <service-type>]
        <subnet>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--name <name>

  Updated name of the subnet

--dhcp

  Enable DHCP

--no-dhcp

  Disable DHCP

--dns-publish-fixed-ip

  Enable publishing fixed IPs in DNS

--no-dns-publish-fixed-ip

  Disable publishing fixed IPs in DNS

--gateway <gateway>

  Specify a gateway for the subnet. The options are: <ip-address>: Specific IP address to use as the gateway, ‘none’: This subnet will not use a gateway. For example, –gateway 192.168.9.1 or –gateway none.

--network-segment <network-segment>

  Network segment to associate with this subnet (name or ID). It is only allowed to set the segment if the current value is None. The network must also have only one segment and only one subnet can exist on the network.

--description <description>

  Set subnet description

--tag <tag>

  Tag to be added to the subnet (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the subnet. Specify both –tag and –no-tag to overwrite current tags

--allocation-pool start=<ip-address>,end=<ip-address>

  Allocation pool IP addresses for this subnet, for example, start=192.168.199.2,end=192.168.199.254 (repeat option to add multiple IP addresses)

--no-allocation-pool

  Clear associated allocation-pools from the subnet. Specify both –allocation-pool and –no-allocation-pool to overwrite the current allocation pool information.

--dns-nameserver <dns-nameserver>

  DNS server for this subnet (repeat option to set multiple DNS servers)

--no-dns-nameservers

  Clear existing information of DNS Nameservers. Specify both –dns-nameserver and –no-dns-nameserver to overwrite the current DNS Nameserver information.

--host-route destination=<subnet>,gateway=<ip-address>

  Additional route for this subnet, for example, destination=10.10.0.0/16,gateway=192.168.71.254 destination: destination subnet (in CIDR notation) gateway: next-hop IP address (repeat option to add multiple routes)

--no-host-route

  Clear associated host-routes from the subnet. Specify both –host-route and –no-host-route to overwrite the current host route information.

--service-type <service-type>

  Service type for this subnet, for example, network:floatingip_agent_gateway. Must be a valid device owner value for a network port (repeat option to set multiple service types)

subnet

  Subnet to modify (name or ID)

### subnet show

Display subnet details

    openstack subnet show <subnet>

subnet

  Subnet to display (name or ID)

### subnet unset

Unset subnet properties

    openstack subnet unset
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--allocation-pool start=<ip-address>,end=<ip-address>]
        [--gateway]
        [--dns-nameserver <dns-nameserver>]
        [--host-route destination=<subnet>,gateway=<ip-address>]
        [--service-type <service-type>]
        [--tag
        <tag>
        |
        --all-tag
        ]
        <subnet>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--allocation-pool start=<ip-address>,end=<ip-address>

  Allocation pool IP addresses to be removed from this subnet, for example, start=192.168.199.2,end=192.168.199.254 (repeat option to unset multiple allocation pools)

--gateway

  Remove gateway IP from this subnet

--dns-nameserver <dns-nameserver>

  DNS server to be removed from this subnet (repeat option to unset multiple DNS servers)

--host-route destination=<subnet>,gateway=<ip-address>

  Route to be removed from this subnet, for example, destination=10.10.0.0/16,gateway=192.168.71.254 destination: destination subnet (in CIDR notation) gateway: next-hop IP address (repeat option to unset multiple host routes)

--service-type <service-type>

  Service type to be removed from this subnet, for example, network:floatingip_agent_gateway. Must be a valid device owner value for a network port (repeat option to unset multiple service types)

--tag <tag>

  Tag to be removed from the subnet (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the subnet

subnet

  Subnet to modify (name or ID)

this page last updated: 2026-07-15 15:33:41

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.